diff --git a/cli/src/cli-cmd-parser.c b/cli/src/cli-cmd-parser.c
index 652b44e89b0..d47b704a80e 100644
--- a/cli/src/cli-cmd-parser.c
+++ b/cli/src/cli-cmd-parser.c
@@ -2380,177 +2380,6 @@ cli_cmd_volume_replace_brick_parse(const char **words, int wordcount,
     return ret;
 }
 
-int32_t
-cli_cmd_log_filename_parse(const char **words, int wordcount, dict_t **options)
-{
-    dict_t *dict = NULL;
-    char *volname = NULL;
-    char *str = NULL;
-    int ret = -1;
-    char *delimiter = NULL;
-
-    GF_ASSERT(words);
-    GF_ASSERT(options);
-
-    dict = dict_new();
-    if (!dict)
-        goto out;
-
-    volname = (char *)words[3];
-    GF_ASSERT(volname);
-
-    ret = dict_set_str(dict, "volname", volname);
-    if (ret)
-        goto out;
-
-    str = (char *)words[4];
-    if (strchr(str, ':')) {
-        delimiter = strchr(words[4], ':');
-        if (!delimiter || delimiter == words[4] || *(delimiter + 1) != '/') {
-            cli_err(
-                "wrong brick type: %s, use <HOSTNAME>:"
-                "<export-dir-abs-path>",
-                words[4]);
-            ret = -1;
-            goto out;
-        } else {
-            ret = gf_canonicalize_path(delimiter + 1);
-            if (ret)
-                goto out;
-        }
-        ret = dict_set_str(dict, "brick", str);
-        if (ret)
-            goto out;
-        /* Path */
-        str = (char *)words[5];
-        ret = dict_set_str(dict, "path", str);
-        if (ret)
-            goto out;
-    } else {
-        ret = dict_set_str(dict, "path", str);
-        if (ret)
-            goto out;
-    }
-
-    *options = dict;
-
-out:
-    if (ret && dict)
-        dict_unref(dict);
-
-    return ret;
-}
-
-int32_t
-cli_cmd_log_level_parse(const char **words, int worcount, dict_t **options)
-{
-    dict_t *dict = NULL;
-    int ret = -1;
-
-    GF_ASSERT(words);
-    GF_ASSERT(options);
-
-    /*
-     * loglevel command format:
-     *  > volume log level <VOL> <XLATOR[*]> <LOGLEVEL>
-     *  > volume log level colon-o posix WARNING
-     *  > volume log level colon-o replicate* DEBUG
-     *  > volume log level coon-o * TRACE
-     */
-
-    GF_ASSERT((strncmp(words[0], "volume", 6) == 0));
-    GF_ASSERT((strncmp(words[1], "log", 3) == 0));
-    GF_ASSERT((strncmp(words[2], "level", 5) == 0));
-
-    ret = glusterd_check_log_level(words[5]);
-    if (ret == -1) {
-        cli_err("Invalid log level [%s] specified", words[5]);
-        cli_err(
-            "Valid values for loglevel: (DEBUG|WARNING|ERROR"
-            "|CRITICAL|NONE|TRACE)");
-        goto out;
-    }
-
-    dict = dict_new();
-    if (!dict)
-        goto out;
-
-    GF_ASSERT(words[3]);
-    GF_ASSERT(words[4]);
-
-    ret = dict_set_str(dict, "volname", (char *)words[3]);
-    if (ret)
-        goto out;
-
-    ret = dict_set_str(dict, "xlator", (char *)words[4]);
-    if (ret)
-        goto out;
-
-    ret = dict_set_str(dict, "loglevel", (char *)words[5]);
-    if (ret)
-        goto out;
-
-    *options = dict;
-
-out:
-    if (ret && dict)
-        dict_unref(dict);
-
-    return ret;
-}
-
-int32_t
-cli_cmd_log_locate_parse(const char **words, int wordcount, dict_t **options)
-{
-    dict_t *dict = NULL;
-    char *volname = NULL;
-    char *str = NULL;
-    int ret = -1;
-    char *delimiter = NULL;
-
-    GF_ASSERT(words);
-    GF_ASSERT(options);
-
-    dict = dict_new();
-    if (!dict)
-        goto out;
-
-    volname = (char *)words[3];
-    GF_ASSERT(volname);
-
-    ret = dict_set_str(dict, "volname", volname);
-    if (ret)
-        goto out;
-
-    if (words[4]) {
-        delimiter = strchr(words[4], ':');
-        if (!delimiter || delimiter == words[4] || *(delimiter + 1) != '/') {
-            cli_err(
-                "wrong brick type: %s, use <HOSTNAME>:"
-                "<export-dir-abs-path>",
-                words[4]);
-            ret = -1;
-            goto out;
-        } else {
-            ret = gf_canonicalize_path(delimiter + 1);
-            if (ret)
-                goto out;
-        }
-        str = (char *)words[4];
-        ret = dict_set_str(dict, "brick", str);
-        if (ret)
-            goto out;
-    }
-
-    *options = dict;
-
-out:
-    if (ret && dict)
-        dict_unref(dict);
-
-    return ret;
-}
-
 int32_t
 cli_cmd_log_rotate_parse(const char **words, int wordcount, dict_t **options)
 {
@@ -4199,26 +4028,6 @@ cli_snap_create_desc_parse(dict_t *dict, const char **words, size_t wordcount,
     return ret;
 }
 
-/* Function to check whether the Volume name is repeated */
-int
-cli_check_if_volname_repeated(const char **words, unsigned int start_index,
-                              uint64_t cur_index)
-{
-    uint64_t i = -1;
-    int ret = 0;
-
-    GF_ASSERT(words);
-
-    for (i = start_index; i < cur_index; i++) {
-        if (strcmp(words[i], words[cur_index]) == 0) {
-            ret = -1;
-            goto out;
-        }
-    }
-out:
-    return ret;
-}
-
 /* snapshot clone <clonename> <snapname>
  * @arg-0, dict     : Request Dictionary to be sent to server side.
  * @arg-1, words    : Contains individual words of CLI command.
diff --git a/cli/src/cli-cmd-volume.c b/cli/src/cli-cmd-volume.c
index 3f2bfdb7999..993d629a3e1 100644
--- a/cli/src/cli-cmd-volume.c
+++ b/cli/src/cli-cmd-volume.c
@@ -571,63 +571,6 @@ cli_cmd_volume_stop_cbk(struct cli_state *state, struct cli_cmd_word *word,
     return ret;
 }
 
-int
-cli_cmd_volume_rename_cbk(struct cli_state *state, struct cli_cmd_word *word,
-                          const char **words, int wordcount)
-{
-    int ret = -1;
-    rpc_clnt_procedure_t *proc = NULL;
-    call_frame_t *frame = NULL;
-    dict_t *dict = NULL;
-    int sent = 0;
-    int parse_error = 0;
-
-    if (wordcount != 4) {
-        cli_usage_out(word->pattern);
-        parse_error = 1;
-        goto out;
-    }
-
-    dict = dict_new();
-    if (!dict)
-        goto out;
-
-    ret = dict_set_str(dict, "old-volname", (char *)words[2]);
-
-    if (ret)
-        goto out;
-
-    ret = dict_set_str(dict, "new-volname", (char *)words[3]);
-
-    if (ret)
-        goto out;
-
-    proc = &cli_rpc_prog->proctable[GLUSTER_CLI_RENAME_VOLUME];
-
-    if (proc->fn) {
-        frame = create_frame(THIS, THIS->ctx->pool);
-        if (!frame) {
-            ret = -1;
-            goto out;
-        }
-        ret = proc->fn(frame, THIS, dict);
-    }
-
-out:
-    if (dict)
-        dict_unref(dict);
-
-    if (ret) {
-        cli_cmd_sent_status_get(&sent);
-        if ((sent == 0) && (parse_error == 0))
-            cli_out("Volume rename on '%s' failed", (char *)words[2]);
-    }
-
-    CLI_STACK_DESTROY(frame);
-
-    return ret;
-}
-
 int
 cli_cmd_volume_defrag_cbk(struct cli_state *state, struct cli_cmd_word *word,
                           const char **words, int wordcount)
@@ -1957,15 +1900,6 @@ cli_cmd_volume_replace_brick_cbk(struct cli_state *state,
     return ret;
 }
 
-int
-cli_cmd_volume_set_transport_cbk(struct cli_state *state,
-                                 struct cli_cmd_word *word, const char **words,
-                                 int wordcount)
-{
-    cli_cmd_broadcast_response(0);
-    return 0;
-}
-
 int
 cli_cmd_volume_top_cbk(struct cli_state *state, struct cli_cmd_word *word,
                        const char **words, int wordcount)
@@ -3038,10 +2972,6 @@ struct cli_cmd volume_cmds[] = {
     {"volume stop <VOLNAME> [force]", cli_cmd_volume_stop_cbk,
      "stop volume specified by <VOLNAME>"},
 
-    /*{ "volume rename <VOLNAME> <NEW-VOLNAME>",
-      cli_cmd_volume_rename_cbk,
-      "rename volume <VOLNAME> to <NEW-VOLNAME>"},*/
-
     {"volume add-brick <VOLNAME> [<replica> <COUNT> "
      "[arbiter <COUNT>]] <NEW-BRICK> ... [force]",
      cli_cmd_volume_add_brick_cbk, "add brick to volume <VOLNAME>"},
@@ -3058,10 +2988,6 @@ struct cli_cmd volume_cmds[] = {
      "{commit force}",
      cli_cmd_volume_replace_brick_cbk, "replace-brick operations"},
 
-    /*{ "volume set-transport <VOLNAME> <TRANSPORT-TYPE> [<TRANSPORT-TYPE>]
-      ...", cli_cmd_volume_set_transport_cbk, "set transport type for volume
-      <VOLNAME>"},*/
-
     {"volume set <VOLNAME> <KEY> <VALUE>", cli_cmd_volume_set_cbk,
      "set options for volume <VOLNAME>"},
 
diff --git a/cli/src/cli-quotad-client.c b/cli/src/cli-quotad-client.c
index 772b8f75bd9..460c38cf7b0 100644
--- a/cli/src/cli-quotad-client.c
+++ b/cli/src/cli-quotad-client.c
@@ -10,6 +10,10 @@
 
 #include "cli-quotad-client.h"
 
+
+// Function not called anywhere in the code
+
+/*
 int
 cli_quotad_submit_request(void *req, call_frame_t *frame, rpc_clnt_prog_t *prog,
                           int procnum, struct iobref *iobref, xlator_t *this,
@@ -47,7 +51,7 @@ cli_quotad_submit_request(void *req, call_frame_t *frame, rpc_clnt_prog_t *prog,
         iov.iov_base = iobuf->ptr;
         iov.iov_len = iobuf_size(iobuf);
 
-        /* Create the xdr payload */
+        // Create the xdr payload
         ret = xdr_serialize_generic(iov, req, xdrproc);
         if (ret == -1) {
             goto out;
@@ -56,7 +60,7 @@ cli_quotad_submit_request(void *req, call_frame_t *frame, rpc_clnt_prog_t *prog,
         count = 1;
     }
 
-    /* Send the msg */
+    // Send the msg
     ret = rpc_clnt_submit(global_quotad_rpc, prog, procnum, cbkfn, &iov, count,
                           NULL, 0, iobref, frame, NULL, 0, NULL, 0, NULL);
     ret = 0;
@@ -69,6 +73,7 @@ cli_quotad_submit_request(void *req, call_frame_t *frame, rpc_clnt_prog_t *prog,
 
     return ret;
 }
+*/
 
 int
 cli_quotad_notify(struct rpc_clnt *rpc, void *mydata, rpc_clnt_event_t event,
diff --git a/cli/src/cli-quotad-client.h b/cli/src/cli-quotad-client.h
index 71a44e5916b..b0a931aa3ee 100644
--- a/cli/src/cli-quotad-client.h
+++ b/cli/src/cli-quotad-client.h
@@ -16,10 +16,11 @@
 #include "protocol-common.h"
 #include "cli-mem-types.h"
 
-int
+/* int
 cli_quotad_submit_request(void *req, call_frame_t *frame, rpc_clnt_prog_t *prog,
                           int procnum, struct iobref *iobref, xlator_t *this,
                           fop_cbk_fn_t cbkfn, xdrproc_t xdrproc);
+*/
 
 struct rpc_clnt *
 cli_quotad_clnt_init(xlator_t *this, dict_t *options);
diff --git a/cli/src/cli-rpc-ops.c b/cli/src/cli-rpc-ops.c
index 1b88414ab0b..4dae3389e0b 100644
--- a/cli/src/cli-rpc-ops.c
+++ b/cli/src/cli-rpc-ops.c
@@ -1797,56 +1797,6 @@ gf_cli_defrag_volume_cbk(struct rpc_req *req, struct iovec *iov, int count,
     return ret;
 }
 
-static int
-gf_cli_rename_volume_cbk(struct rpc_req *req, struct iovec *iov, int count,
-                         void *myframe)
-{
-    gf_cli_rsp rsp = {
-        0,
-    };
-    int ret = -1;
-    char msg[1024] = {
-        0,
-    };
-
-    GF_ASSERT(myframe);
-
-    if (-1 == req->rpc_status) {
-        goto out;
-    }
-
-    ret = xdr_to_generic(*iov, &rsp, (xdrproc_t)xdr_gf_cli_rsp);
-    if (ret < 0) {
-        gf_log(((call_frame_t *)myframe)->this->name, GF_LOG_ERROR,
-               XDR_DECODE_FAIL);
-        goto out;
-    }
-
-    gf_log("cli", GF_LOG_INFO, "Received resp to probe");
-    snprintf(msg, sizeof(msg), "Rename volume %s",
-             (rsp.op_ret) ? "unsuccessful" : "successful");
-
-    if (global_state->mode & GLUSTER_MODE_XML) {
-        ret = cli_xml_output_str("volRename", msg, rsp.op_ret, rsp.op_errno,
-                                 rsp.op_errstr);
-        if (ret)
-            gf_log("cli", GF_LOG_ERROR, XML_ERROR);
-        goto out;
-    }
-
-    if (rsp.op_ret)
-        cli_err("volume rename: failed");
-    else
-        cli_out("volume rename: success");
-
-    ret = rsp.op_ret;
-
-out:
-    cli_cmd_broadcast_response(ret);
-    gf_free_xdr_cli_rsp(rsp);
-    return ret;
-}
-
 static int
 gf_cli_reset_volume_cbk(struct rpc_req *req, struct iovec *iov, int count,
                         void *myframe)
@@ -4124,39 +4074,14 @@ gf_cli_defrag_volume(call_frame_t *frame, xlator_t *this, void *data)
     return ret;
 }
 
+/* This function is obsolete and not used anymore, keeping it as a dummy
+ * function */
+
 static int32_t
 gf_cli_rename_volume(call_frame_t *frame, xlator_t *this, void *data)
 {
-    gf_cli_req req = {{
-        0,
-    }};
-    int ret = 0;
-    dict_t *dict = NULL;
-
-    if (!frame || !this || !data) {
-        ret = -1;
-        goto out;
-    }
-
-    dict = data;
-
-    ret = dict_allocate_and_serialize(dict, &req.dict.dict_val,
-                                      &req.dict.dict_len);
-    if (ret < 0) {
-        gf_log(this->name, GF_LOG_ERROR, DICT_SERIALIZE_FAIL);
-
-        goto out;
-    }
-
-    ret = cli_cmd_submit(NULL, &req, frame, cli_rpc_prog,
-                         GLUSTER_CLI_RENAME_VOLUME, NULL, this,
-                         gf_cli_rename_volume_cbk, (xdrproc_t)xdr_gf_cli_req);
-
-out:
-    GF_FREE(req.dict.dict_val);
-    gf_log("cli", GF_LOG_DEBUG, RETURNING, ret);
-
-    return ret;
+    gf_log("cli", GF_LOG_WARNING, "This option is depreciated");
+    return -1;
 }
 
 static int32_t
diff --git a/rpc/rpc-lib/src/protocol-common.h b/rpc/rpc-lib/src/protocol-common.h
index 34592beffd4..96c10b1d51d 100644
--- a/rpc/rpc-lib/src/protocol-common.h
+++ b/rpc/rpc-lib/src/protocol-common.h
@@ -159,7 +159,7 @@ enum gluster_cli_procnum {
     GLUSTER_CLI_DELETE_VOLUME,
     GLUSTER_CLI_START_VOLUME,
     GLUSTER_CLI_STOP_VOLUME,
-    GLUSTER_CLI_RENAME_VOLUME,
+    GLUSTER_CLI_RENAME_VOLUME,  // This option is obsolete and not used anymore
     GLUSTER_CLI_DEFRAG_VOLUME,
     GLUSTER_CLI_SET_VOLUME,
     GLUSTER_CLI_ADD_BRICK,
diff --git a/tests/line-coverage/cli-negative-case-and-function-coverage.t b/tests/line-coverage/cli-negative-case-and-function-coverage.t
new file mode 100644
index 00000000000..bbfc54243d2
--- /dev/null
+++ b/tests/line-coverage/cli-negative-case-and-function-coverage.t
@@ -0,0 +1,93 @@
+#!/bin/bash
+
+. $(dirname $0)/../include.rc
+
+cleanup;
+
+# Start glusterd
+TEST glusterd;
+TEST pidof glusterd;
+
+# Checking various negative cases of gluster cli
+# Wrong brick type
+TEST ! $CLI volume create ${V0}_1 $H0-$B0/v{1..2}
+
+# Wrong hostname
+TEST ! $CLI volume create ${V0}_1 $S0:$B0/v{1..2}
+
+# 'localhost' as hostname not allowed
+TEST ! $CLI volume create ${V0}_1 localhost:$B0/v{1..2}
+
+# inode-quota option
+# volume name not provided
+TEST ! $CLI volume inode-quota disable
+
+# only enabling is allowed
+TEST ! $CLI volume inode-quota ${V0}_1 disable
+
+# quota options
+# provide wrong value
+TEST ! $CLI volume ${V0}_1 start
+TEST ! $CLI volume ${V0}_1 limit-usage /random-path 0
+TEST ! $CLI volume ${V0}_1 limit-objects /random-path 0
+TEST ! $CLI volume ${V0}_1 alert-time some-time
+TEST ! $CLI volume ${V0}_1 soft-timeout some-time
+TEST ! $CLI volume ${V0}_1 hard-timeout some-time
+
+# absolute path not given
+TEST ! $CLI volume ${V0}_1 limit-usage random-path
+TEST ! $CLI volume ${V0}_1 remove random-path
+TEST ! $CLI volume ${V0}_1 remove-objects random-path
+TEST ! $CLI volume ${V0}_1 list random-path
+
+# value not provided
+TEST ! $CLI volume ${V0}_1 remove /random-path
+TEST ! $CLI volume ${V0}_1 remove-objects /random-path
+TEST ! $CLI volume ${V0}_1 alert-time
+TEST ! $CLI volume ${V0}_1 soft-timeout
+TEST ! $CLI volume ${V0}_1 hard-timeout
+TEST ! $CLI volume ${V0}_1 default-soft-limit
+
+# nfs-ganesha options
+TEST ! $CLI nfs-ganesha
+TEST ! $CLI nfs-gansha disable
+TEST ! $CLI nfs-ganesha stop
+TEST ! $CLI nfs-ganesha disable
+TEST ! $CLI nfs-ganesha enable
+
+# peer options
+TEST ! $CLI peer probe
+TEST ! $CLI peer probe host_name
+TEST ! $CLI peer detach
+TEST ! $CLI peer detach host-name random-option
+TEST ! $CLI peer status host
+TEST ! $CLI pool list host
+
+# vol sync option
+TEST ! $CLI vol sync
+TEST ! $CLI vol sync host-name
+TEST ! $CLI vol sync localhost
+
+# system commands
+TEST ! $CLI system:: getspec
+TEST ! $CLI system:: portmap brick2port
+TEST ! $CLI system:: fsm log random-peer random-value
+TEST ! $CLI system:: getwd random-value
+TEST ! $CLI system:: mount
+TEST ! $CLI system:: umount
+TEST ! $CLI system:: uuid get random-value
+TEST ! $CLI system:: uuid reset random-value
+TEST ! $CLI system:: execute
+TEST ! $CLI system:: copy file
+
+# volume status statistics
+TEST $CLI volume create ${V0}_1 replica 3 $H0:$B0/v{1..3}
+TEST $CLI volume start ${V0}_1
+TEST $CLI volume heal ${V0}_1 statistics
+
+# xml options
+TEST $CLI volume replace-brick ${V0}_1 $H0:$B0/v1 $H0:$B0/v4 commit force --xml
+TEST $CLI volume create ${V0}_2 $H0:$B0/v{5..6} --xml
+TEST $CLI volume delete ${V0}_2 --xml
+
+cleanup;
